Package org.codehaus.groovy.tools

## Class ErrorReporter

- java.lang.Object
- - org.codehaus.groovy.tools.ErrorReporter

-     public class ErrorReporter
      extends Object

  Provides services for reporting compilation errors to the user. Primary entry point is `write()`.

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ErrorReporter​(Throwable e)` | Configures a new Reporter.
    `ErrorReporter​(Throwable e, boolean debug)` | Configures a new Reporter.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `protected void` | `dispatch​(Throwable object, boolean child)` | Runs the report once all initialization is complete.
    `protected void` | `println​(String line)` | Prints a line to the underlying `PrintStream`
    `protected void` | `println​(StringBuffer line)` |
    `protected void` | `report​(Exception e, boolean child)` | For Exception.
    `protected void` | `report​(Throwable e, boolean child)` | For everything else.
    `protected void` | `report​(CompilationFailedException e, boolean child)` | For CompilationFailedException.
    `protected void` | `report​(GroovyExceptionInterface e, boolean child)` | For GroovyException.
    `protected void` | `stacktrace​(Throwable e, boolean always)` | Displays an exception's stack trace, if `debug` or `always`.
    `void` | `write​(PrintStream stream)` | Writes the error to the specified `PrintStream`.
    `void` | `write​(PrintWriter writer)` | Writes the error to the specified `PrintWriter`.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ErrorReporter

          public ErrorReporter​(Throwable e)

      Configures a new Reporter. Default mode is not to report a stack trace unless the error was not of one of the supported types.
      Parameters:
        `e` - the exception on which to report

    - #### ErrorReporter

          public ErrorReporter​(Throwable e,
                               boolean debug)

      Configures a new Reporter.
      Parameters:
        `e` - the exception on which to report
        `debug` - if set, stack traces will be output for all reports

  - ### Method Detail

    - #### write

          public void write​(PrintStream stream)

      Writes the error to the specified `PrintStream`.

    - #### write

          public void write​(PrintWriter writer)

      Writes the error to the specified `PrintWriter`.

    - #### dispatch

          protected void dispatch​(Throwable object,
                                  boolean child)

      Runs the report once all initialization is complete.

    - #### report

          protected void report​(CompilationFailedException e,
                                boolean child)

      For CompilationFailedException.

    - #### report

          protected void report​(GroovyExceptionInterface e,
                                boolean child)

      For GroovyException.

    - #### report

          protected void report​(Exception e,
                                boolean child)

      For Exception.

    - #### report

          protected void report​(Throwable e,
                                boolean child)

      For everything else.

    - #### println

          protected void println​(String line)

      Prints a line to the underlying `PrintStream`

    - #### println

          protected void println​(StringBuffer line)

    - #### stacktrace

          protected void stacktrace​(Throwable e,
                                    boolean always)

      Displays an exception's stack trace, if `debug` or `always`.